Unit IA10R1_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure IA10R1(var CX :Array of Real; var NX :Integer; AX :Real;
                BX :Real; EPS :Real; NXM :Integer; KX :Integer;
                IDX :Integer; JX :Integer; var TX :Array of Real);

implementation

procedure IA10R1(var CX :Array of Real; var NX :Integer; AX :Real;
                BX :Real; EPS :Real; NXM :Integer; KX :Integer;
                IDX :Integer; JX :Integer; var TX :Array of Real);
var
I,J,K,L,M :Integer;
A,B,C,D,E,F,G,H :Real;
const
C1 :Real = 1.0;
C2 :Real = 0.5;
C3 :Real = 0.166667;
C4 :Real = 0.14087;
C5 :Real = 0.055556;
C6 :Real = 0.030382;
C7 :Real = 1.0E-6;
K1 :Integer = 1;
K2 :Integer = 2;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130;
begin
I  := KX - K2 - IDX;
K  := K2 + K1;
L  := K + K1;
A  := C4;
if ( KX  =  L ) 
 then A  := C3;
if ( I  =  L ) 
 then A  := C6;
if ( I  =  K ) 
 then A  := C5;
if ( I  =  K1 ) 
 then A  := C2;
if ( JX  <  K1 ) 
 then goto _90;
M  := NXM + K2;
TX[K-1] := AX;
H  := (BX - AX)/(NX - K1);
_10:
J  := Trunc( ((TX[K-1]-AX) / H) + K1 );
L  := J + K1;
B  := CX[J-1] + (TX[K-1] - AX - (J - K1)*H)*(CX[L-1] - CX[J-1])/H;
_20:
if ( B  <  CX[L-1] ) 
 then goto _40;
C  := A*B*(IntPower(AX + J*H - TX[K-1],I));
if ( C  >  EPS ) 
 then goto _50;
_30:
J  := L;
L  := L + K1;
if ( J  <  NX ) 
 then goto _20;
NX  := K - K1;
K  := K + K1;
TX[K-1] := BX;
goto _130;
_40:
C  := CX[L-1]*A*(IntPower(AX + J*H - TX[K-1],I));
if ( C  >  EPS ) 
 then goto _60;
B  := CX[L-1];
goto _30;
_50:
J  := K;
K  := K + K1;
TX[K-1] := TX[J-1] + (Power(EPS/A/B,C1/I));
if ( K  <  M ) 
 then goto _10;
goto _80;
_60:
D  := AX + (J - K1)*H + (B - CX[J-1])*H/(CX[L-1] - CX[J-1]);
C  := A*B*(IntPower(D - TX[K-1],I));
if ( C  >  EPS ) 
 then goto _50;
E  := AX + J*H;
F  := B;
G  := CX[L-1];
_70:
B  := C2*(D + E);
C  := A*C2*(G + F)*(IntPower(B - TX[K-1],I));
if ( C  >  EPS )
 then E  := B;
if ( C  >  EPS ) 
 then G  := C2*(F + G);
if ( C  <=  EPS ) 
 then D  := B;
if ( C  <=  EPS ) 
 then F  := C2*(F + G);
B  := E - D;
if ( B  >=  C7 ) 
 then goto _70;
K  := K + K1;
TX[K-1] := D;
if ( K  <  M ) 
 then goto _10;
_80:
NX  := NXM;
goto _110;
_90:
B  := CX[K1-1];
for J:=K2 to NX do
 begin
  if ( CX[J-1] >  B ) 
   then B  := CX[J-1];
_100:
 end;
H  := (BX - AX)/(NXM - K1);
C  := B*A*(IntPower(H,I));
if ( C  >  EPS ) 
 then goto _80;
NX  := Trunc( K2 + (BX - AX)*(Trunc(Power(B*(A/EPS),C1/I))) );
if ( NX  >  NXM ) 
 then goto _80;
_110:
H  := (BX - AX)/(NX - K1);
for I:=K1 to NX do
 begin
  J  := I + K2;
  TX[J-1] := AX + (I - K1)*H;
_120:
 end;
_130:
I  := K2*K2;
A  := TX[I-1] - AX;
TX[K2-1] := AX - A;
TX[K1-1] := AX - K2*A;
I  := NX + K1;
J  := I + K2;
K  := J + K1;
A  := BX - TX[I-1];
TX[J-1] := BX + A;
TX[K-1] := BX + K2*A;
end;

end.
